multicraft.register_craftitem("throwing:arrow", {
    description = "Arrow",
    inventory_image = "throwing_arrow_inv.png",
    groups = {combat = 1},
})

multicraft.register_node("throwing:arrow_box", {
    drawtype = "nodebox",
    node_box = {
        type = "fixed",
        fixed = {
            -- Shaft
            {-6.5/17, -1.5/17, -1.5/17, 6.5/17, 1.5/17, 1.5/17},
            --Spitze
            {-4.5/17, 2.5/17, 2.5/17, -3.5/17, -2.5/17, -2.5/17},
            {-8.5/17, 0.5/17, 0.5/17, -6.5/17, -0.5/17, -0.5/17},
            --Federn
            {6.5/17, 1.5/17, 1.5/17, 7.5/17, 2.5/17, 2.5/17},
            {7.5/17, -2.5/17, 2.5/17, 6.5/17, -1.5/17, 1.5/17},
            {7.5/17, 2.5/17, -2.5/17, 6.5/17, 1.5/17, -1.5/17},
            {6.5/17, -1.5/17, -1.5/17, 7.5/17, -2.5/17, -2.5/17},

            {7.5/17, 2.5/17, 2.5/17, 8.5/17, 3.5/17, 3.5/17},
            {8.5/17, -3.5/17, 3.5/17, 7.5/17, -2.5/17, 2.5/17},
            {8.5/17, 3.5/17, -3.5/17, 7.5/17, 2.5/17, -2.5/17},
            {7.5/17, -2.5/17, -2.5/17, 8.5/17, -3.5/17, -3.5/17},
        }
    },
    tiles = {"throwing_arrow.png", "throwing_arrow.png", "throwing_arrow_back.png", "throwing_arrow_front.png", "throwing_arrow_2.png", "throwing_arrow.png"},
    groups = {not_in_creative_inventory=1},
})

local THROWING_ARROW_ENTITY={
    physical = false,
    timer=0,
    visual = "wielditem",
    visual_size = {x=0.4, y=0.4},
    --textures = {"throwing:arrow_box"},
    textures = {"throwing_arrow_back.png"},
    lastpos={},
    collisionbox = {0,0,0,0,0,0},
}

THROWING_ARROW_ENTITY.on_step = function(self, dtime)
    self.timer=self.timer+dtime
    local pos = self.object:getpos()
    local node = multicraft.get_node(pos)

    if self.timer>0.2 then
        local objs = multicraft.get_objects_inside_radius({x=pos.x,y=pos.y,z=pos.z}, 2)
        for k, obj in pairs(objs) do
            if obj:get_luaentity() ~= nil then
                if obj:get_luaentity().name ~= "throwing:arrow_entity" and obj:get_luaentity().name ~= "__builtin:item" then
                    local damage = 3
                    obj:punch(self.object, 1.0, {
                        full_punch_interval=1.0,
                        damage_groups={fleshy=damage},
                    }, nil)
                    self.object:remove()
                end
            else
                local damage = 3
                obj:punch(self.object, 1.0, {
                    full_punch_interval=1.0,
                    damage_groups={fleshy=damage},
                }, nil)
                self.object:remove()
            end
        end
    end

    if self.lastpos.x~=nil then
        if node.name ~= "air" then
            multicraft.add_item(self.lastpos, 'throwing:arrow')
            self.object:remove()
        end
    end
    self.lastpos={x=pos.x, y=pos.y, z=pos.z}
end

multicraft.register_entity("throwing:arrow_entity", THROWING_ARROW_ENTITY)

multicraft.register_craft({
    output = 'throwing:arrow 4',
    recipe = {
        {'default:flint'},
        {'default:stick'},
        {'default:paper'}
    }
})
